define(["ecm/model/Action","dojo/_base/lang", 
    "dojo/_base/declare","ecm/model/Request","ecm/model/Desktop"],function(Action,lang,declare, Request, Desktop){
	
	var oEcm=ecm;
	
	
	return declare("printAsPDFPluginDojo.actions.PrintAsPDFAction",[Action],{
		
		
		
		canPerformAction : function (repository, itemList, listType, teamspace, resultSet){
			return true;
		},
		
		isEnabled : function(repository, listType, items, teamspace, resultSet){
			return true;
		},
		
		isGlobalEnabled : function(resultSet, items, repository){
			return false; 	
		},
		
		isVisible : function(repository, items, repositoryTypes, teamspace){
			return true;
		},

		performAction: function(repository, itemList, callback, teamspace, resultSet, parameterMap){
			 var actionDownloadAsPdf=this._rescopeActionDownloadAsPdfWithInterceptor(lang.hitch(this,function (response){
				 this._requestPrintablePDFFromCachedPDF(response);
			 }));
			 
			 actionDownloadAsPdf.apply(this,arguments);
		},
		_requestPrintablePDFFromCachedPDF : function (response){
			
			/*Request.invokePluginService("PrintAsPDFPlugin","GetContentAsPrintablePDF", {
				requestParams: response,
				requestCompleteCallback : function (result){
					debugger;
				},
				requestFailedCallback : function (error){
					debugger;
				}
			});*/
			var baseURL=location.protocol + '//' + location.host + location.pathname;
			
			var pluginService="jaxrs/plugin?plugin=PrintAsPDFPlugin&action=GetContentAsPrintablePDF";
			var cacheParam = "&packagedContentCacheId="+response.packagedContentCacheId;
			
			var url=ecm.model.Request.appendSecurityToken(baseURL+pluginService+cacheParam);

			var iFrame = document.createElement("iframe");
			iFrame.style.display = "none";
			iFrame.src = url;
			document.body.appendChild(iFrame);
			
		},
		_rescopeActionDownloadAsPdfWithInterceptor : function (interceptor){	
			
			var ecm = lang.mixin({},oEcm);
			ecm.model = lang.mixin({},oEcm.model);
			var Request = ecm.model.Request = lang.mixin({},oEcm.model.Request);
			
			Request.invokeServiceAPI=function (serviceName, repositoryType, params) {
				if (serviceName !=="convertDocument") 
					throw "Uncompatible with current Navigator version";
				params.requestCompleteCallback=interceptor;
				oEcm.model.Request.invokeServiceAPI.apply(oEcm.model.Request,arguments);
			} 
			
			var ah=Desktop.getActionsHandler();
		
			if (!ah._downloadAsPdf)
				throw new "Uncompatible with current Navigator version";
			
			var reScopedActionDownloadAsPDF = eval("("+ah._downloadAsPdf.toString()+")");
			
			return lang.hitch(ah,reScopedActionDownloadAsPDF);
		}
	});
});